function A = OnlineML2(x,y,z,A_0,params)
%disp('Running Online Metric Learning...');
if ~exist('params')
    params = struct();
end
if ~isfield(params,'eta')
    params.eta = 1;
end
if ~isfield(params,'margin')
    params.margin = 1;
end
eta = params.eta;
marg = params.margin;
A = A_0;
[c,t] = size(x);
for i = 1:c
    %i1 = C(i,1);
    %i2 = C(i,2);
    %i3 = C(i,3);
    p = x(i,:) - y(i,:);
    q = x(i,:) - z(i,:);
    a_0 = p*A*p';
    b_0 = q*A*q';
    c_0 = p*A*q';
    good_constraint = 1;
    %check for weird conditions
    %if norm(q) < 1e-10 || norm(p) < 1e-10 || norm(q-p) < 1e-10 || abs(a_0) ...
	%  < 1e-10 || abs(b_0) < 1e-10 || abs(c_0) < 1e-10
    %    good_constraint = 0;
    %end
    %check for alpha = 0 and only perform update if necessary
    if a_0 > b_0 - 1 && good_constraint == 1
        %t = -2*a_0*b_0 + 2*c_0*c_0 + a_0 - b_0;
        %alpha = (t + sqrt(t*t + 4*(a_0*b_0-c_0*c_0)*(a_0-b_0+1)))/(2*(a_0* ...
	%					  b_0-c_0*c_0));
        t = -2*a_0*b_0 + 2*c_0*c_0 + marg*a_0 - marg*b_0;
        if c_0 == 0 && a_0 == 0
            alpha = (1-b_0)/b_0;
        else
            alpha = (t + sqrt(t*t + 4*marg*(a_0*b_0-c_0*c_0)*(a_0-b_0+marg)))/(2*marg*(a_0*b_0-c_0*c_0));
        end
            %if we get a weird alpha, ignore this constraint
        if abs(alpha) > 1e8 || isnan(alpha)
	        alpha = 0;
        end
	    %use updates that don't compute inverses:
	    if alpha > eta
            %disp('alpha = eta');
            v = A*p';
            B = A - (eta / (1 + eta*a_0))*v*v';
            w = B*q';
            A = B + (eta / (1 - eta*q*B*q'))*w*w';
        else
            %disp('0 < alpha < eta');
            v = A*p';
            B = A - (alpha / (1 + alpha*a_0))*v*v';
            w = B*q';
            A = B + (alpha / (1 - alpha*q*B*q'))*w*w';
        end
    else
        %disp('alpha = 0');
    end
end
