#!/bin/bash

#Find a 2x2 Mahalanobis distance for pairs of states (s, s'), each of which is made up of two state variables (x1 and x2)


#convert data from
# * <x1> <x2> <action> <x1'> <x2'> <reward>
#format
./getStates.sh $1

#learning parameter
eta=0.01

#which action should I learn a distance metric for?
action=1

#get states for action $action that are "close together" to form tupples
nice python ./processForMatlab.py $1.states $action > $action.$1

#learn a distance metric
echo $action.$1
nice matlab -nosplash -nodesktop -r doRun3\($eta,\'$action.$1\'\) > $action.$eta.$1

#get the distance metric, per update
egrep "^[0-9]" $action.$eta.$1 > metric.$action.$eta.$1

#print out the final metric for action $action, with learning rate $eta in format:
#<Update #> <A00> <A01> <A10> <A11>
tail -n1 metric.$action.$eta.$1
